unit Main;

{$mode objfpc}{$H+}

{.$DEFINE CLAUDE}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Grids, ShellCtrls, Menus, ListViewFilterEdit, JvTabBar, JvPageList,
  JvTabBarXPPainter;

type

  { TMainForm }

  TMainForm = class(TForm)
    bttnAddTab: TButton;
    cbCloseButton: TCheckBox;
    cbAllowTabMoving: TCheckBox;
    cbTabHotTracking: TCheckBox;
    cmbPainter: TComboBox;
    cmbOrientation: TComboBox;
    Image1: TImage;
    ImageList1: TImageList;
    JvModernTabBarPainter1: TJvModernTabBarPainter;
    JvPageList1: TJvPageList;
    JvStandardPage1: TJvStandardPage;
    JvStandardPage2: TJvStandardPage;
    JvStandardPage3: TJvStandardPage;
    JvStandardPage4: TJvStandardPage;
    JvTabBar1: TJvTabBar;
    JvTabBarXPPainter1: TJvTabBarXPPainter;
    lblPainter: TLabel;
    lblOrientation: TLabel;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Panel1: TPanel;
    ShellListView1: TShellListView;
    ShellTreeView1: TShellTreeView;
    Splitter1: TSplitter;
    StringGrid1: TStringGrid;
    procedure bttnAddTabClick(Sender: TObject);
    procedure cbCloseButtonChange(Sender: TObject);
    procedure cbAllowTabMovingChange(Sender: TObject);
    procedure cbTabHotTrackingChange(Sender: TObject);
    procedure cmbPainterChange(Sender: TObject);
    procedure cmbOrientationChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure JvTabBar1TabCloseQuery(Sender: TObject; Item: TJvTabBarItem;
      var CanClose: Boolean);

    {$ifdef CLAUDE}
    procedure MenuItem2Click(Sender: TObject);
    {$endif}
  private
     iMeinCounter:integer;
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
  unit1 {$ifdef CLAUDE},unit2 {$endif};

{$R *.lfm}

{ TMainForm }

procedure TMainForm.cbCloseButtonChange(Sender: TObject);
begin
  JvTabBar1.CloseButton := cbCloseButton.Checked;
end;

procedure TMainForm.bttnAddTabClick(Sender: TObject);
var
  s:string;
  aForm: TForm1;
  i:integer;
  aTab:TJvTabBarItem;
begin
  inc(iMeinCounter);
  s:='Ein Tab '+inttostr(iMeinCounter);
  aTab:=JvTabBar1.AddTab(s);  //offensichtlich wird auch gleichzeitig eine jvStandardpage in der Pagelist angelegt und synchronisiert.
  aTab.ImageIndex:=1;
  JvTabBar1.SelectedTab:=aTab;

  { die Aufgabe ist es ein Formular in die richtige Seite der JvPagelist einzukleben.
    ob direkt mit parent oder auch über die Dockingfunktion ist erstmal egal

    Letztlich soll die Funktion so sein dass es eine TForm entweder gedockt/eingeklebt oder "frei fliegend" sein kann.
  }

  aForm:=TForm1.Create(self);
  {hier kracht es auch deswegen weil eine3 TJvStandardpage kein TWincontrol ist.
   aber irgendwie muss es ja klappen denn in der GU kann man Controls einkleben.

   kommentiert man die nächsten 4 Zeilen aus klappt es mit einer leeren Seite.
  }

  aForm.Parent := JvTabBar1.PageList.;  // <=== hier kracht es
  aForm.BorderStyle:=bsNone;
  aForm.Align:=alclient;
  aForm.Show;

end;

procedure TMainForm.cbTabHotTrackingChange(Sender: TObject);
begin
  JvTabBar1.HotTracking := cbTabHotTracking.Checked;
end;

procedure TMainForm.cbAllowTabMovingChange(Sender: TObject);
begin
  JvTabBar1.AllowTabMoving := cbAllowTabMoving.Checked;
end;

procedure TMainForm.cmbPainterChange(Sender: TObject);
begin
  case cmbPainter.ItemIndex of
    0: JvTabBar1.Painter := JvModernTabBarPainter1;
    1: JvTabBar1.Painter := JvTabBarXPPainter1;
  end;
end;

procedure TMainForm.JvTabBar1TabCloseQuery(Sender: TObject;
  Item: TJvTabBarItem; var CanClose: Boolean);
begin
  CanClose := MessageDlg('Do you really want to close tab ' + Item.Caption + '?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

{$ifdef CLAUDE}

procedure TMainForm.MenuItem2Click(Sender: TObject);
var
  aForm:TFormClaude;
begin
  aForm:=TFormClaude.Create(self);
  //aForm.Parent := JvPageList1.Pages[i+1];
  //aForm.BorderStyle:=bsNone;
  aForm.Align:=alclient;
  aForm.ShowModal;
end;

{$endif}

procedure TMainForm.cmbOrientationChange(Sender: TObject);
begin
  case cmbOrientation.ItemIndex of
    0: begin
         JvTabBar1.Orientation := toTop;
         JvTabBar1.Align := alTop;
       end;
    1: begin
         JvTabBar1.Orientation := toBottom;
         JvTabBar1.Align := alBottom;
       end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  iMeinCounter:=0;
  {$ifdef CLAUDE} MenuItem2.OnClick:= @MenuItem2Click; {$endif};
end;

end.

